diff --git a/gcc/config/sparc/sparc.c b/gcc/config/sparc/sparc.c
index f52b976..5c8d002 100644
--- a/gcc/config/sparc/sparc.c
+++ b/gcc/config/sparc/sparc.c
@@ -444,7 +444,7 @@ static const struct processor_costs *sparc_costs = &cypress_costs;
 #define LEAF_SIBCALL_SLOT_RESERVED_P 1
 #else
 #define LEAF_SIBCALL_SLOT_RESERVED_P \
-  ((TARGET_ARCH64 && !TARGET_CM_MEDLOW) || flag_pic)
+  ((TARGET_ARCH64 && !TARGET_CM_MEDLOW) || GCC_OPTION (flag_pic))
 #endif
 
 /* Vector to say how input registers are mapped to output registers.
@@ -875,7 +875,7 @@ static bool
 sparc_gate_work_around_errata (void)
 {
   /* The only errata we handle are those of the AT697F and UT699.  */
-  return sparc_fix_at697f != 0 || sparc_fix_ut699 != 0;
+  return GCC_OPTION (sparc_fix_at697f) != 0 || GCC_OPTION (sparc_fix_ut699) != 0;
 }
 
 static unsigned int
@@ -897,7 +897,7 @@ sparc_do_work_around_errata (void)
 	insn = XVECEXP (PATTERN (insn), 0, 1);
 
       /* Look for a single-word load into an odd-numbered FP register.  */
-      if (sparc_fix_at697f
+      if (GCC_OPTION (sparc_fix_at697f)
 	  && NONJUMP_INSN_P (insn)
 	  && (set = single_set (insn)) != NULL_RTX
 	  && GET_MODE_SIZE (GET_MODE (SET_SRC (set))) == 4
@@ -967,7 +967,7 @@ sparc_do_work_around_errata (void)
 	}
 
       /* Look for a single-word load into an integer register.  */
-      else if (sparc_fix_ut699
+      else if (GCC_OPTION (sparc_fix_ut699)
 	       && NONJUMP_INSN_P (insn)
 	       && (set = single_set (insn)) != NULL_RTX
 	       && GET_MODE_SIZE (GET_MODE (SET_SRC (set))) <= 4
@@ -1013,7 +1013,7 @@ sparc_do_work_around_errata (void)
 	}
 
       /* Look for a single-word load/operation into an FP register.  */
-      else if (sparc_fix_ut699
+      else if (GCC_OPTION (sparc_fix_ut699)
 	       && NONJUMP_INSN_P (insn)
 	       && (set = single_set (insn)) != NULL_RTX
 	       && GET_MODE_SIZE (GET_MODE (SET_SRC (set))) == 4
@@ -1309,12 +1309,12 @@ sparc_option_override (void)
   unsigned int i;
   int fpu;
 
-  if (sparc_debug_string != NULL)
+  if (GCC_OPTION (sparc_debug_string) != NULL)
     {
       const char *q;
       char *p;
 
-      p = ASTRDUP (sparc_debug_string);
+      p = ASTRDUP (GCC_OPTION (sparc_debug_string));
       while ((q = strtok (p, ",")) != NULL)
 	{
 	  bool invert;
@@ -1337,15 +1337,15 @@ sparc_option_override (void)
 	    error ("unknown -mdebug-%s switch", q);
 
 	  if (invert)
-	    sparc_debug &= ~mask;
+	    GCC_OPTION (sparc_debug) &= ~mask;
 	  else
-	    sparc_debug |= mask;
+	    GCC_OPTION (sparc_debug) |= mask;
 	}
     }
 
   if (TARGET_DEBUG_OPTIONS)
     {
-      dump_target_flags("Initial target_flags", target_flags);
+      dump_target_flags("Initial target_flags", GCC_OPTION (target_flags));
       dump_target_flags("target_flags_explicit", target_flags_explicit);
     }
 
@@ -1364,7 +1364,7 @@ sparc_option_override (void)
   if (TARGET_64BIT && ! TARGET_LONG_DOUBLE_128)
     {
       error ("-mlong-double-64 not allowed with -m64");
-      target_flags |= MASK_LONG_DOUBLE_128;
+      GCC_OPTION (target_flags) |= MASK_LONG_DOUBLE_128;
     }
 
   /* Code model selection.  */
@@ -1375,15 +1375,15 @@ sparc_option_override (void)
     sparc_cmodel = CM_32;
 #endif
 
-  if (sparc_cmodel_string != NULL)
+  if (GCC_OPTION (sparc_cmodel_string) != NULL)
     {
       if (TARGET_ARCH64)
 	{
 	  for (cmodel = &cmodels[0]; cmodel->name; cmodel++)
-	    if (strcmp (sparc_cmodel_string, cmodel->name) == 0)
+	    if (strcmp (GCC_OPTION (sparc_cmodel_string), cmodel->name) == 0)
 	      break;
 	  if (cmodel->name == NULL)
-	    error ("bad value (%s) for -mcmodel= switch", sparc_cmodel_string);
+	    error ("bad value (%s) for -mcmodel= switch", GCC_OPTION (sparc_cmodel_string));
 	  else
 	    sparc_cmodel = cmodel->value;
 	}
@@ -1399,7 +1399,7 @@ sparc_option_override (void)
         call_used_regs [i] = 1;
       }
 
-  fpu = target_flags & MASK_FPU; /* save current -mfpu status */
+  fpu = GCC_OPTION (target_flags) & MASK_FPU; /* save current -mfpu status */
 
   /* Set the default CPU.  */
   if (!global_options_set.x_sparc_cpu_and_features)
@@ -1408,25 +1408,25 @@ sparc_option_override (void)
 	if (def->cpu == TARGET_CPU_DEFAULT)
 	  break;
       gcc_assert (def->cpu != -1);
-      sparc_cpu_and_features = def->processor;
+      GCC_OPTION (sparc_cpu_and_features) = def->processor;
     }
 
   if (!global_options_set.x_sparc_cpu)
-    sparc_cpu = sparc_cpu_and_features;
+    GCC_OPTION (sparc_cpu) = GCC_OPTION (sparc_cpu_and_features);
 
-  cpu = &cpu_table[(int) sparc_cpu_and_features];
+  cpu = &cpu_table[(int) GCC_OPTION (sparc_cpu_and_features)];
 
   if (TARGET_DEBUG_OPTIONS)
     {
       fprintf (stderr, "sparc_cpu_and_features: %s\n", cpu->name);
       fprintf (stderr, "sparc_cpu: %s\n",
-	       cpu_table[(int) sparc_cpu].name);
+	       cpu_table[(int) GCC_OPTION (sparc_cpu)].name);
       dump_target_flags ("cpu->disable", cpu->disable);
       dump_target_flags ("cpu->enable", cpu->enable);
     }
 
-  target_flags &= ~cpu->disable;
-  target_flags |= (cpu->enable
+  GCC_OPTION (target_flags) &= ~cpu->disable;
+  GCC_OPTION (target_flags) |= (cpu->enable
 #ifndef HAVE_AS_FMAF_HPC_VIS3
 		   & ~(MASK_FMAF | MASK_VIS3)
 #endif
@@ -1441,59 +1441,59 @@ sparc_option_override (void)
   /* If -mfpu or -mno-fpu was explicitly used, don't override with
      the processor default.  */
   if (target_flags_explicit & MASK_FPU)
-    target_flags = (target_flags & ~MASK_FPU) | fpu;
+    GCC_OPTION (target_flags) = (GCC_OPTION (target_flags) & ~MASK_FPU) | fpu;
 
   /* -mvis2 implies -mvis */
   if (TARGET_VIS2)
-    target_flags |= MASK_VIS;
+    GCC_OPTION (target_flags) |= MASK_VIS;
 
   /* -mvis3 implies -mvis2 and -mvis */
   if (TARGET_VIS3)
-    target_flags |= MASK_VIS2 | MASK_VIS;
+    GCC_OPTION (target_flags) |= MASK_VIS2 | MASK_VIS;
 
   /* Don't allow -mvis, -mvis2, -mvis3, or -mfmaf if FPU is
      disabled.  */
   if (! TARGET_FPU)
-    target_flags &= ~(MASK_VIS | MASK_VIS2 | MASK_VIS3 | MASK_FMAF);
+    GCC_OPTION (target_flags) &= ~(MASK_VIS | MASK_VIS2 | MASK_VIS3 | MASK_FMAF);
 
   /* -mvis assumes UltraSPARC+, so we are sure v9 instructions
      are available.
      -m64 also implies v9.  */
   if (TARGET_VIS || TARGET_ARCH64)
     {
-      target_flags |= MASK_V9;
-      target_flags &= ~(MASK_V8 | MASK_SPARCLET | MASK_SPARCLITE);
+      GCC_OPTION (target_flags) |= MASK_V9;
+      GCC_OPTION (target_flags) &= ~(MASK_V8 | MASK_SPARCLET | MASK_SPARCLITE);
     }
 
   /* -mvis also implies -mv8plus on 32-bit */
   if (TARGET_VIS && ! TARGET_ARCH64)
-    target_flags |= MASK_V8PLUS;
+    GCC_OPTION (target_flags) |= MASK_V8PLUS;
 
   /* Use the deprecated v8 insns for sparc64 in 32 bit mode.  */
   if (TARGET_V9 && TARGET_ARCH32)
-    target_flags |= MASK_DEPRECATED_V8_INSNS;
+    GCC_OPTION (target_flags) |= MASK_DEPRECATED_V8_INSNS;
 
   /* V8PLUS requires V9, makes no sense in 64 bit mode.  */
   if (! TARGET_V9 || TARGET_ARCH64)
-    target_flags &= ~MASK_V8PLUS;
+    GCC_OPTION (target_flags) &= ~MASK_V8PLUS;
 
   /* Don't use stack biasing in 32 bit mode.  */
   if (TARGET_ARCH32)
-    target_flags &= ~MASK_STACK_BIAS;
+    GCC_OPTION (target_flags) &= ~MASK_STACK_BIAS;
 
   /* Supply a default value for align_functions.  */
-  if (align_functions == 0
-      && (sparc_cpu == PROCESSOR_ULTRASPARC
-	  || sparc_cpu == PROCESSOR_ULTRASPARC3
-	  || sparc_cpu == PROCESSOR_NIAGARA
-	  || sparc_cpu == PROCESSOR_NIAGARA2
-	  || sparc_cpu == PROCESSOR_NIAGARA3
-	  || sparc_cpu == PROCESSOR_NIAGARA4))
-    align_functions = 32;
+  if (GCC_OPTION (align_functions) == 0
+      && (GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC3
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA2
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA3
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA4))
+    GCC_OPTION (align_functions) = 32;
 
   /* Validate PCC_STRUCT_RETURN.  */
-  if (flag_pcc_struct_return == DEFAULT_PCC_STRUCT_RETURN)
-    flag_pcc_struct_return = (TARGET_ARCH64 ? 0 : 1);
+  if (GCC_OPTION (flag_pcc_struct_return) == DEFAULT_PCC_STRUCT_RETURN)
+    GCC_OPTION (flag_pcc_struct_return) = (TARGET_ARCH64 ? 0 : 1);
 
   /* Only use .uaxword when compiling for a 64-bit target.  */
   if (!TARGET_ARCH64)
@@ -1505,7 +1505,7 @@ sparc_option_override (void)
   /* Set up function hooks.  */
   init_machine_status = sparc_init_machine_status;
 
-  switch (sparc_cpu)
+  switch (GCC_OPTION (sparc_cpu))
     {
     case PROCESSOR_V7:
     case PROCESSOR_CYPRESS:
@@ -1555,51 +1555,51 @@ sparc_option_override (void)
       gcc_unreachable ();
     };
 
-  if (sparc_memory_model == SMM_DEFAULT)
+  if (GCC_OPTION (sparc_memory_model) == SMM_DEFAULT)
     {
       /* Choose the memory model for the operating system.  */
       enum sparc_memory_model_type os_default = SUBTARGET_DEFAULT_MEMORY_MODEL;
       if (os_default != SMM_DEFAULT)
-	sparc_memory_model = os_default;
+	GCC_OPTION (sparc_memory_model) = os_default;
       /* Choose the most relaxed model for the processor.  */
       else if (TARGET_V9)
-	sparc_memory_model = SMM_RMO;
+	GCC_OPTION (sparc_memory_model) = SMM_RMO;
       else if (TARGET_LEON3)
-	sparc_memory_model = SMM_TSO;
+	GCC_OPTION (sparc_memory_model) = SMM_TSO;
       else if (TARGET_LEON)
-	sparc_memory_model = SMM_SC;
+	GCC_OPTION (sparc_memory_model) = SMM_SC;
       else if (TARGET_V8)
-	sparc_memory_model = SMM_PSO;
+	GCC_OPTION (sparc_memory_model) = SMM_PSO;
       else
-	sparc_memory_model = SMM_SC;
+	GCC_OPTION (sparc_memory_model) = SMM_SC;
     }
 
 #ifdef TARGET_DEFAULT_LONG_DOUBLE_128
   if (!(target_flags_explicit & MASK_LONG_DOUBLE_128))
-    target_flags |= MASK_LONG_DOUBLE_128;
+    GCC_OPTION (target_flags) |= MASK_LONG_DOUBLE_128;
 #endif
 
   if (TARGET_DEBUG_OPTIONS)
-    dump_target_flags ("Final target_flags", target_flags);
+    dump_target_flags ("Final target_flags", GCC_OPTION (target_flags));
 
   maybe_set_param_value (PARAM_SIMULTANEOUS_PREFETCHES,
-			 ((sparc_cpu == PROCESSOR_ULTRASPARC
-			   || sparc_cpu == PROCESSOR_NIAGARA
-			   || sparc_cpu == PROCESSOR_NIAGARA2
-			   || sparc_cpu == PROCESSOR_NIAGARA3
-			   || sparc_cpu == PROCESSOR_NIAGARA4)
+			 ((GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA2
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA3
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA4)
 			  ? 2
-			  : (sparc_cpu == PROCESSOR_ULTRASPARC3
+			  : (GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC3
 			     ? 8 : 3)),
 			 global_options.x_param_values,
 			 global_options_set.x_param_values);
   maybe_set_param_value (PARAM_L1_CACHE_LINE_SIZE,
-			 ((sparc_cpu == PROCESSOR_ULTRASPARC
-			   || sparc_cpu == PROCESSOR_ULTRASPARC3
-			   || sparc_cpu == PROCESSOR_NIAGARA
-			   || sparc_cpu == PROCESSOR_NIAGARA2
-			   || sparc_cpu == PROCESSOR_NIAGARA3
-			   || sparc_cpu == PROCESSOR_NIAGARA4)
+			 ((GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC3
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA2
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA3
+			   || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA4)
 			  ? 64 : 32),
 			 global_options.x_param_values,
 			 global_options_set.x_param_values);
@@ -1608,7 +1608,7 @@ sparc_option_override (void)
      The IRA sharing algorithm works on single registers only and this
      pessimizes for double floating-point registers.  */
   if (!global_options_set.x_flag_ira_share_save_slots)
-    flag_ira_share_save_slots = 0;
+    GCC_OPTION (flag_ira_share_save_slots) = 0;
 
   /* We register a machine specific pass to work around errata, if any.
      The pass mut be scheduled as late as possible so that we have the
@@ -1725,7 +1725,7 @@ can_use_mov_pic_label_ref (rtx label)
 
   /* Finally, if we are reordering basic blocks and partition into hot
      and cold sections, this might happen for any label.  */
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     return false;
 
   return true;
@@ -1760,7 +1760,7 @@ sparc_expand_move (enum machine_mode mode, rtx *operands)
     }
 
   /* Fixup PIC cases.  */
-  if (flag_pic && CONSTANT_P (operands[1]))
+  if (GCC_OPTION (flag_pic) && CONSTANT_P (operands[1]))
     {
       if (pic_address_needs_scratch (operands[1]))
 	operands[1] = sparc_legitimize_pic_address (operands[1], NULL_RTX);
@@ -3734,7 +3734,7 @@ sparc_cannot_force_const_mem (enum machine_mode mode, rtx x)
 
     case LABEL_REF:
       /* Labels are OK iff we are non-PIC.  */
-      return flag_pic != 0;
+      return GCC_OPTION (flag_pic) != 0;
 
     case SYMBOL_REF:
       /* 'Naked' TLS symbol references are never OK,
@@ -3742,7 +3742,7 @@ sparc_cannot_force_const_mem (enum machine_mode mode, rtx x)
       if (SYMBOL_REF_TLS_MODEL (x))
 	return true;
       else
-	return flag_pic != 0;
+	return GCC_OPTION (flag_pic) != 0;
 
     case CONST:
       return sparc_cannot_force_const_mem (mode, XEXP (x, 0));
@@ -3781,7 +3781,7 @@ check_pic (int i)
 {
   rtx op;
 
-  switch (flag_pic)
+  switch (GCC_OPTION (flag_pic))
     {
     case 1:
       op = recog_data.operand[i];
@@ -3870,12 +3870,12 @@ constant_address_p (rtx x)
       return true;
 
     case CONST:
-      if (flag_pic && pic_address_needs_scratch (x))
+      if (GCC_OPTION (flag_pic) && pic_address_needs_scratch (x))
 	return false;
       return sparc_legitimate_constant_p (Pmode, x);
 
     case SYMBOL_REF:
-      return !flag_pic && sparc_legitimate_constant_p (Pmode, x);
+      return !GCC_OPTION (flag_pic) && sparc_legitimate_constant_p (Pmode, x);
 
     default:
       return false;
@@ -3935,7 +3935,7 @@ sparc_legitimate_address_p (enum machine_mode mode, rtx addr, bool strict)
 	  rs2 = XEXP (addr, 0);
 	}
 
-      if ((flag_pic == 1
+      if ((GCC_OPTION (flag_pic) == 1
 	   && rs1 == pic_offset_table_rtx
 	   && !REG_P (rs2)
 	   && GET_CODE (rs2) != SUBREG
@@ -3972,7 +3972,7 @@ sparc_legitimate_address_p (enum machine_mode mode, rtx addr, bool strict)
 	     DFmode/DImode because then mem_min_alignment is likely to be zero
 	     after reload and the  forced split would lack a matching splitter
 	     pattern.  */
-	  if (TARGET_ARCH32 && !optimize
+	  if (TARGET_ARCH32 && !GCC_OPTION (optimize)
 	      && (mode == DFmode || mode == DImode))
 	    return 0;
 	}
@@ -4061,7 +4061,7 @@ static rtx
 sparc_tls_got (void)
 {
   /* In PIC mode, this is just the PIC offset table.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       crtl->uses_pic_offset_table = 1;
       return pic_offset_table_rtx;
@@ -4264,7 +4264,7 @@ sparc_legitimize_pic_address (rtx orig, rtx reg)
 	  reg = gen_reg_rtx (Pmode);
 	}
 
-      if (flag_pic == 2)
+      if (GCC_OPTION (flag_pic) == 2)
 	{
 	  /* If not during reload, allocate another temp reg here for loading
 	     in the address, so that these instructions can be optimized
@@ -4391,7 +4391,7 @@ sparc_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
 
   if (sparc_tls_referenced_p (x))
     x = sparc_legitimize_tls_address (x);
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     x = sparc_legitimize_pic_address (x, NULL_RTX);
   else if (GET_CODE (x) == PLUS && CONSTANT_ADDRESS_P (XEXP (x, 1)))
     x = gen_rtx_PLUS (Pmode, XEXP (x, 0),
@@ -4465,7 +4465,7 @@ sparc_legitimize_reload_address (rtx x, enum machine_mode mode,
       && GET_CODE (x) != LO_SUM
       && GET_CODE (x) != HIGH
       && sparc_cmodel <= CM_MEDLOW
-      && !(flag_pic
+      && !(GCC_OPTION (flag_pic)
 	   && (symbolic_operand (x, Pmode) || pic_address_needs_scratch (x))))
     {
       x = gen_rtx_LO_SUM (GET_MODE (x), gen_rtx_HIGH (GET_MODE (x), x), x);
@@ -4508,7 +4508,7 @@ static bool
 sparc_mode_dependent_address_p (const_rtx addr,
 				addr_space_t as ATTRIBUTE_UNUSED)
 {
-  if (flag_pic && GET_CODE (addr) == PLUS)
+  if (GCC_OPTION (flag_pic) && GET_CODE (addr) == PLUS)
     {
       rtx op0 = XEXP (addr, 0);
       rtx op1 = XEXP (addr, 1);
@@ -4546,16 +4546,16 @@ get_pc_thunk_name (char name[32], unsigned int regno)
 static rtx
 gen_load_pcrel_sym (rtx op0, rtx op1, rtx op2, rtx op3)
 {
-  int orig_flag_pic = flag_pic;
+  int orig_flag_pic = GCC_OPTION (flag_pic);
   rtx insn;
 
   /* The load_pcrel_sym{si,di} patterns require absolute addressing.  */
-  flag_pic = 0;
+  GCC_OPTION (flag_pic) = 0;
   if (TARGET_ARCH64)
     insn = gen_load_pcrel_symdi (op0, op1, op2, op3);
   else
     insn = gen_load_pcrel_symsi (op0, op1, op2, op3);
-  flag_pic = orig_flag_pic;
+  GCC_OPTION (flag_pic) = orig_flag_pic;
 
   return insn;
 }
@@ -4606,7 +4606,7 @@ sparc_emit_call_insn (rtx pat, rtx addr)
 
   /* The PIC register is live on entry to VxWorks PIC PLT entries.  */
   if (TARGET_VXWORKS_RTP
-      && flag_pic
+      && GCC_OPTION (flag_pic)
       && GET_CODE (addr) == SYMBOL_REF
       && (SYMBOL_REF_DECL (addr)
 	  ? !targetm.binds_local_p (SYMBOL_REF_DECL (addr))
@@ -4673,7 +4673,7 @@ mem_min_alignment (rtx mem, int desired)
 	     unaligned pointer to local stack though.  */
 	  if (((cfun != 0
 		&& REGNO_POINTER_ALIGN (regno) >= desired * BITS_PER_UNIT)
-	       || (optimize && reload_completed))
+	       || (GCC_OPTION (optimize) && reload_completed))
 	      && (INTVAL (offset) & (desired - 1)) == 0)
 	    return 1;
 	}
@@ -5472,14 +5472,14 @@ sparc_expand_prologue (void)
      example, the regrename pass has special provisions to not rename to
      non-leaf registers in a leaf function.  */
   sparc_leaf_function_p
-    = optimize > 0 && crtl->is_leaf && only_leaf_regs_used ();
+    = GCC_OPTION (optimize) > 0 && crtl->is_leaf && only_leaf_regs_used ();
 
   size = sparc_compute_frame_size (get_frame_size(), sparc_leaf_function_p);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = size;
 
-  if (flag_stack_check == STATIC_BUILTIN_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == STATIC_BUILTIN_STACK_CHECK)
     {
       if (crtl->is_leaf && !cfun->calls_alloca)
 	{
@@ -5583,14 +5583,14 @@ sparc_flat_expand_prologue (void)
   HOST_WIDE_INT size;
   rtx insn;
 
-  sparc_leaf_function_p = optimize > 0 && crtl->is_leaf;
+  sparc_leaf_function_p = GCC_OPTION (optimize) > 0 && crtl->is_leaf;
 
   size = sparc_compute_frame_size (get_frame_size(), sparc_leaf_function_p);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = size;
 
-  if (flag_stack_check == STATIC_BUILTIN_STACK_CHECK)
+  if (GCC_OPTION (flag_stack_check) == STATIC_BUILTIN_STACK_CHECK)
     {
       if (crtl->is_leaf && !cfun->calls_alloca)
 	{
@@ -5897,7 +5897,7 @@ output_return (rtx insn)
 	 machinery occupies the delay slot.  */
       gcc_assert (!final_sequence);
 
-      if (flag_delayed_branch)
+      if (GCC_OPTION (flag_delayed_branch))
 	{
 	  if (!TARGET_FLAT && TARGET_V9)
 	    fputs ("\treturn\t%i7+8\n", asm_out_file);
@@ -5963,7 +5963,7 @@ output_return (rtx insn)
 	  /* The delay slot is empty.  */
 	  if (TARGET_V9)
 	    return "return\t%%i7+%)\n\t nop";
-	  else if (flag_delayed_branch)
+	  else if (GCC_OPTION (flag_delayed_branch))
 	    return "jmp\t%%i7+%)\n\t restore";
 	  else
 	    return "restore\n\tjmp\t%%o7+%)\n\t nop";
@@ -5980,7 +5980,7 @@ output_sibcall (rtx insn, rtx call_operand)
 {
   rtx operands[1];
 
-  gcc_assert (flag_delayed_branch);
+  gcc_assert (GCC_OPTION (flag_delayed_branch));
 
   operands[0] = call_operand;
 
@@ -7250,7 +7250,7 @@ sparc_struct_value_rtx (tree fndecl, int incoming)
          Variable size structure returns are handled per the normal
          procedures in GCC. This is enabled by -mstd-struct-return */
       if (incoming == 2
-	  && sparc_std_struct_return
+	  && GCC_OPTION (sparc_std_struct_return)
 	  && TYPE_SIZE_UNIT (TREE_TYPE (fndecl))
 	  && TREE_CODE (TYPE_SIZE_UNIT (TREE_TYPE (fndecl))) == INTEGER_CST)
 	{
@@ -8762,13 +8762,13 @@ sparc_print_operand (FILE *file, rtx x, int code)
 	 this is a dbx bug.  So, we only do this when optimizing.
          On UltraSPARC, a branch in a delay slot causes a pipeline flush.
 	 Always emit a nop in case the next instruction is a branch.  */
-      if (! final_sequence && (optimize && (int)sparc_cpu < PROCESSOR_V9))
+      if (! final_sequence && (GCC_OPTION (optimize) && (int)GCC_OPTION (sparc_cpu) < PROCESSOR_V9))
 	fputs (",a", file);
       return;
     case '(':
       /* Output a 'nop' if there's nothing for the delay slot and we are
 	 not optimizing.  This is always used with '*' above.  */
-      if (! final_sequence && ! (optimize && (int)sparc_cpu < PROCESSOR_V9))
+      if (! final_sequence && ! (GCC_OPTION (optimize) && (int)GCC_OPTION (sparc_cpu) < PROCESSOR_V9))
 	fputs ("\n\t nop", file);
       else if (final_sequence)
         sparc_indent_opcode = 1;
@@ -8785,7 +8785,7 @@ sparc_print_operand (FILE *file, rtx x, int code)
 	 when sparc_std_struct_return is enabled. */
      if (!TARGET_ARCH64
 	 && cfun->returns_struct
-	 && !sparc_std_struct_return
+	 && !GCC_OPTION (sparc_std_struct_return)
 	 && DECL_SIZE (DECL_RESULT (current_function_decl))
 	 && TREE_CODE (DECL_SIZE (DECL_RESULT (current_function_decl)))
 	     == INTEGER_CST
@@ -9092,7 +9092,7 @@ sparc_print_operand_address (FILE *file, rtx x)
       output_address (XEXP (addr, 1));
       fputc (')', file);
     }
-  else if (flag_pic
+  else if (GCC_OPTION (flag_pic)
 	   && GET_CODE (addr) == CONST
 	   && GET_CODE (XEXP (addr, 0)) == MINUS
 	   && GET_CODE (XEXP (XEXP (addr, 0), 1)) == CONST
@@ -9340,12 +9340,12 @@ sparc32_initialize_trampoline (rtx m_tramp, rtx fnaddr, rtx cxt)
   /* On UltraSPARC a flush flushes an entire cache line.  The trampoline is
      aligned on a 16 byte boundary so one flush clears it all.  */
   emit_insn (gen_flushsi (validize_mem (adjust_address (m_tramp, SImode, 0))));
-  if (sparc_cpu != PROCESSOR_ULTRASPARC
-      && sparc_cpu != PROCESSOR_ULTRASPARC3
-      && sparc_cpu != PROCESSOR_NIAGARA
-      && sparc_cpu != PROCESSOR_NIAGARA2
-      && sparc_cpu != PROCESSOR_NIAGARA3
-      && sparc_cpu != PROCESSOR_NIAGARA4)
+  if (GCC_OPTION (sparc_cpu) != PROCESSOR_ULTRASPARC
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_ULTRASPARC3
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA2
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA3
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA4)
     emit_insn (gen_flushsi (validize_mem (adjust_address (m_tramp, SImode, 8))));
 
   /* Call __enable_execute_stack after writing onto the stack to make sure
@@ -9385,12 +9385,12 @@ sparc64_initialize_trampoline (rtx m_tramp, rtx fnaddr, rtx cxt)
   emit_move_insn (adjust_address (m_tramp, DImode, 24), fnaddr);
   emit_insn (gen_flushdi (validize_mem (adjust_address (m_tramp, DImode, 0))));
 
-  if (sparc_cpu != PROCESSOR_ULTRASPARC
-      && sparc_cpu != PROCESSOR_ULTRASPARC3
-      && sparc_cpu != PROCESSOR_NIAGARA
-      && sparc_cpu != PROCESSOR_NIAGARA2
-      && sparc_cpu != PROCESSOR_NIAGARA3
-      && sparc_cpu != PROCESSOR_NIAGARA4)
+  if (GCC_OPTION (sparc_cpu) != PROCESSOR_ULTRASPARC
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_ULTRASPARC3
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA2
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA3
+      && GCC_OPTION (sparc_cpu) != PROCESSOR_NIAGARA4)
     emit_insn (gen_flushdi (validize_mem (adjust_address (m_tramp, DImode, 8))));
 
   /* Call __enable_execute_stack after writing onto the stack to make sure
@@ -9558,7 +9558,7 @@ hypersparc_adjust_cost (rtx insn, rtx link, rtx dep_insn, int cost)
 static int
 sparc_adjust_cost(rtx insn, rtx link, rtx dep, int cost)
 {
-  switch (sparc_cpu)
+  switch (GCC_OPTION (sparc_cpu))
     {
     case PROCESSOR_SUPERSPARC:
       cost = supersparc_adjust_cost (insn, link, dep, cost);
@@ -9582,16 +9582,16 @@ sparc_sched_init (FILE *dump ATTRIBUTE_UNUSED,
 static int
 sparc_use_sched_lookahead (void)
 {
-  if (sparc_cpu == PROCESSOR_NIAGARA
-      || sparc_cpu == PROCESSOR_NIAGARA2
-      || sparc_cpu == PROCESSOR_NIAGARA3)
+  if (GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA
+      || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA2
+      || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA3)
     return 0;
-  if (sparc_cpu == PROCESSOR_NIAGARA4)
+  if (GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA4)
     return 2;
-  if (sparc_cpu == PROCESSOR_ULTRASPARC
-      || sparc_cpu == PROCESSOR_ULTRASPARC3)
+  if (GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC
+      || GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC3)
     return 4;
-  if ((1 << sparc_cpu) &
+  if ((1 << GCC_OPTION (sparc_cpu)) &
       ((1 << PROCESSOR_SUPERSPARC) | (1 << PROCESSOR_HYPERSPARC) |
        (1 << PROCESSOR_SPARCLITE86X)))
     return 3;
@@ -9601,7 +9601,7 @@ sparc_use_sched_lookahead (void)
 static int
 sparc_issue_rate (void)
 {
-  switch (sparc_cpu)
+  switch (GCC_OPTION (sparc_cpu))
     {
     case PROCESSOR_NIAGARA:
     case PROCESSOR_NIAGARA2:
@@ -9804,7 +9804,7 @@ sparc_check_64 (rtx x, rtx insn)
   if (GET_MODE (x) == DImode)
     y = gen_rtx_REG (SImode, REGNO (x) + WORDS_BIG_ENDIAN);
 
-  if (flag_expensive_optimizations
+  if (GCC_OPTION (flag_expensive_optimizations)
       && df && DF_REG_DEF_COUNT (REGNO (y)) == 1)
     set_once = 1;
 
@@ -9968,10 +9968,10 @@ static bool
 sparc_function_ok_for_sibcall (tree decl, tree exp ATTRIBUTE_UNUSED)
 {
   return (decl
-	  && flag_delayed_branch
+	  && GCC_OPTION (flag_delayed_branch)
 	  && (TARGET_ARCH64 || ! cfun->returns_struct)
 	  && !(TARGET_VXWORKS_RTP
-	       && flag_pic
+	       && GCC_OPTION (flag_pic)
 	       && !targetm.binds_local_p (decl)));
 }
 
@@ -11220,12 +11220,12 @@ sparc_register_move_cost (enum machine_mode mode ATTRIBUTE_UNUSED,
 
   if (need_memory)
     {
-      if (sparc_cpu == PROCESSOR_ULTRASPARC
-	  || sparc_cpu == PROCESSOR_ULTRASPARC3
-	  || sparc_cpu == PROCESSOR_NIAGARA
-	  || sparc_cpu == PROCESSOR_NIAGARA2
-	  || sparc_cpu == PROCESSOR_NIAGARA3
-	  || sparc_cpu == PROCESSOR_NIAGARA4)
+      if (GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_ULTRASPARC3
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA2
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA3
+	  || GCC_OPTION (sparc_cpu) == PROCESSOR_NIAGARA4)
 	return 12;
 
       return 6;
@@ -11291,7 +11291,7 @@ sparc_output_mi_thunk (FILE *file, tree thunk_fndecl ATTRIBUTE_UNUSED,
 
       int_arg_first = SPARC_OUTGOING_INT_ARG_FIRST;
     }
-  else if (flag_delayed_branch)
+  else if (GCC_OPTION (flag_delayed_branch))
     {
       /* We will emit a regular sibcall below, so we need to instruct
 	 output_sibcall that we are in a leaf function.  */
@@ -11396,7 +11396,7 @@ sparc_output_mi_thunk (FILE *file, tree thunk_fndecl ATTRIBUTE_UNUSED,
     }
   funexp = XEXP (DECL_RTL (function), 0);
 
-  if (flag_delayed_branch)
+  if (GCC_OPTION (flag_delayed_branch))
     {
       funexp = gen_rtx_MEM (FUNCTION_MODE, funexp);
       insn = emit_call_insn (gen_sibcall (funexp));
@@ -11408,7 +11408,7 @@ sparc_output_mi_thunk (FILE *file, tree thunk_fndecl ATTRIBUTE_UNUSED,
 	 without using delay slots...  */
       rtx spill_reg, seq, scratch = gen_rtx_REG (Pmode, 1);
 
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
         {
 	  spill_reg = gen_rtx_REG (word_mode, 15);  /* %o7 */
 	  start_sequence ();
@@ -11576,7 +11576,7 @@ sparc_file_end (void)
 	  make_decl_one_only (decl, DECL_ASSEMBLER_NAME (decl));
 	  DECL_VISIBILITY (decl) = VISIBILITY_HIDDEN;
 	  DECL_VISIBILITY_SPECIFIED (decl) = 1;
-	  resolve_unique_section (decl, 0, flag_function_sections);
+	  resolve_unique_section (decl, 0, GCC_OPTION (flag_function_sections));
 	  allocate_struct_function (decl, true);
 	  cfun->is_thunk = 1;
 	  current_function_decl = decl;
@@ -11597,7 +11597,7 @@ sparc_file_end (void)
       if (do_cfi)
 	fprintf (asm_out_file, "\t.cfi_startproc\n");
 #endif
-      if (flag_delayed_branch)
+      if (GCC_OPTION (flag_delayed_branch))
 	fprintf (asm_out_file, "\tjmp\t%%o7+8\n\t add\t%%o7, %s, %s\n",
 		 reg_name, reg_name);
       else
@@ -11649,7 +11649,7 @@ sparc_emit_membar_for_model (enum memmodel model,
 
   int mm = 0, implied = 0;
 
-  switch (sparc_memory_model)
+  switch (GCC_OPTION (sparc_memory_model))
     {
     case SMM_SC:
       /* Sequential Consistency.  All memory transactions are immediately
@@ -12402,7 +12402,7 @@ sparc_secondary_reload (bool in_p, rtx x, reg_class_t rclass_i,
 	&& symbolic_operand (x, mode))
        || (TARGET_CM_EMBMEDANY
 	   && text_segment_operand (x, mode)))
-      && ! flag_pic)
+      && ! GCC_OPTION (flag_pic))
     {
       if (in_p)
 	sri->icode = direct_optab_handler (reload_in_optab, mode);
